mod error;
mod formats;
mod linker;
mod parts;

use formats::ElfObject;
use linker::LinkState;
use parts::Storage;

fn main() {
    let mut args = std::env::args().peekable();

    // can this miss?
    args.next().unwrap();

    let mut contents: Vec<Storage> = Vec::new();
    let mut linker = LinkState::new();

    while args.peek().is_some() {
        let fpath = args.next().expect("Unexpected peek-a-boo");
        let stored = Storage::new(fpath.into());
        contents.push(stored);
    }

    for storage in contents.iter_mut() {
        let relocatable = ElfObject::new(storage).unwrap();
        linker.add_relocatable(Box::new(relocatable)).unwrap();
    }

    let total_size = linker.total_size().expect("Size to be known");
    println!("to allocate: {}", total_size);

    println!("all: \n{}", linker);
}
